module Plasticine
  def self.localize(path, options={})
    options.reverse_merge! format: :date_long

    options[:format] = "plasticine_#{options[:format]}".to_sym

    return I18n.localize(path, options)
  end

  def self.translate(path, options={})
    I18n.translate("plasticine.#{path}", options)
  end

  def self.t(path, options={})
    self.translate path, options
  end
end

require "plasticine/authentication"
require "plasticine/base_visual"
require "plasticine/builder"
require "plasticine/engine"
require "plasticine/railtie"
